/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * FrmSettingMenuIPD.java
 *
 * Created on Aug 25, 2009, 9:13:36 AM
 */

package com.ustasoft.component;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultListModel;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.DefaultTableModel;
import pos.MainForm;

/**
 *
 * @author Administrator
 */
public class FrmSettingMenuGrup extends javax.swing.JInternalFrame {
    private Connection conn;
    GeneralFunction fn=new GeneralFunction();
    private MainForm mainForm;

    /** Creates new form FrmSettingMenuIPD */
    public FrmSettingMenuGrup() {
//        super(parent, modal);
        initComponents();
        jTable1.getColumn("Menu").setPreferredWidth(150);
    }

    private void udfLoadMenuUserAuth() {
        chkAll.setSelected(false);

        String sQry="select m.kode, m.id, m.menu_description, g.menu_id is not null pilih  \n" +
                    "from m_menu_list m\n" +
                    "left join m_menu_list_grouping g on g.menu_id=m.id and g.group_id='"+cmbGroup.getSelectedItem().toString()+"'\n" +
                    "where module_name='POS'\n" +
                    "order by m.kode ";
        try{
            ResultSet rs=conn.createStatement().executeQuery(sQry);
            ((DefaultTableModel)jTable1.getModel()).setNumRows(0);

            while(rs.next()){
                ((DefaultTableModel)jTable1.getModel()).addRow(new Object[]{
                    rs.getString("kode"),
                    rs.getString("menu_description"),
                    rs.getBoolean("pilih"),
                    rs.getInt("id")
                });
            }
            if(jTable1.getRowCount()>0)
                jTable1.setRowSelectionInterval(0, 0);

            jTable1.setModel((DefaultTableModel)fn.autoResizeColWidth(jTable1, (DefaultTableModel)jTable1.getModel()).getModel());
        }catch(SQLException se){
            JOptionPane.showMessageDialog(null, se.getMessage());
        }
    }

    public void setMainForm(MainForm aThis) {
        mainForm=aThis;
    }

    public void setConn(Connection conn) {
        this.conn=conn;
    }

    private void udfSave(){
        String sIns="Delete from m_menu_list_grouping where group_id='"+cmbGroup.getSelectedItem().toString()+"'; ";
        try{
            conn.setAutoCommit(false);
            for (int i=0; i<jTable1.getRowCount(); i++){
                if((Boolean)jTable1.getValueAt(i, jTable1.getColumnModel().getColumnIndex("Pilih"))){
                sIns+=  "Insert into m_menu_list_grouping(menu_id, group_id) VALUES( " +
                        ""+fn.udfGetInt(jTable1.getValueAt(i, jTable1.getColumnModel().getColumnIndex("ID")).toString())+"," +
                        "'"+cmbGroup.getSelectedItem().toString()+"');";
                }
            }
            int iR=conn.createStatement(ResultSet.TYPE_FORWARD_ONLY, ResultSet.CONCUR_UPDATABLE).executeUpdate(sIns);
            conn.setAutoCommit(true);
            
            if (iR>0) JOptionPane.showMessageDialog(this, "Update Successful!");

            mainForm.udfSetUserMenu();

        }catch(SQLException se){
            try {
                conn.setAutoCommit(true);
                conn.rollback();
                JOptionPane.showMessageDialog(this, se.getMessage());
            } catch (SQLException ex) {
                Logger.getLogger(FrmSettingMenuGrup.class.getName()).log(Level.SEVERE, null, ex);
            }

        }
    }

    private void udfInitForm(){
        try{
            ResultSet rs=conn.createStatement().executeQuery("select group_id from m_menu_group order by 1");
            cmbGroup.removeAllItems();
            cmbGroup.addItem("< Semua >");
            while(rs.next()){
                cmbGroup.addItem(rs.getString(1));
            }

            rs.close();
        }catch(SQLException se){
            JOptionPane.showMessageDialog(this, se.getMessage());
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane2 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jLabel2 = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        jButton2 = new javax.swing.JButton();
        jButton1 = new javax.swing.JButton();
        chkAll = new javax.swing.JCheckBox();
        jLabel3 = new javax.swing.JLabel();
        cmbGroup = new javax.swing.JComboBox();

        setClosable(true);
        setTitle("Menu Setting"); // NOI18N
        addInternalFrameListener(new javax.swing.event.InternalFrameListener() {
            public void internalFrameActivated(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameClosed(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameClosing(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameDeactivated(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameDeiconified(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameIconified(javax.swing.event.InternalFrameEvent evt) {
            }
            public void internalFrameOpened(javax.swing.event.InternalFrameEvent evt) {
                formInternalFrameOpened(evt);
            }
        });
        getContentPane().setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Kode", "Menu", "Pilih", "ID"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.String.class, java.lang.Boolean.class, java.lang.Integer.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, true, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable1.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_OFF);
        jTable1.getTableHeader().setReorderingAllowed(false);
        jScrollPane2.setViewportView(jTable1);

        getContentPane().add(jScrollPane2, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 30, 710, 424));

        jLabel2.setFont(new java.awt.Font("Tahoma", 1, 11)); // NOI18N
        jLabel2.setText("Daftar Menu");
        getContentPane().add(jLabel2, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 10, 380, 20));
        getContentPane().add(jSeparator1, new org.netbeans.lib.awtextra.AbsoluteConstraints(180, 474, 240, 10));

        jButton2.setText("Close");
        jButton2.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        getContentPane().add(jButton2, new org.netbeans.lib.awtextra.AbsoluteConstraints(640, 464, 80, 30));

        jButton1.setText("Update");
        jButton1.setMargin(new java.awt.Insets(2, 2, 2, 2));
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        getContentPane().add(jButton1, new org.netbeans.lib.awtextra.AbsoluteConstraints(540, 464, 100, 30));

        chkAll.setText("Check All");
        chkAll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkAllActionPerformed(evt);
            }
        });
        getContentPane().add(chkAll, new org.netbeans.lib.awtextra.AbsoluteConstraints(420, 465, 120, -1));

        jLabel3.setText("Group");
        getContentPane().add(jLabel3, new org.netbeans.lib.awtextra.AbsoluteConstraints(390, 5, 70, 20));

        cmbGroup.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        cmbGroup.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                cmbGroupItemStateChanged(evt);
            }
        });
        cmbGroup.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmbGroupActionPerformed(evt);
            }
        });
        getContentPane().add(cmbGroup, new org.netbeans.lib.awtextra.AbsoluteConstraints(470, 5, 250, -1));

        setBounds(0, 0, 746, 529);
    }// </editor-fold>//GEN-END:initComponents

    private void formInternalFrameOpened(javax.swing.event.InternalFrameEvent evt) {//GEN-FIRST:event_formInternalFrameOpened
        udfInitForm();
    }//GEN-LAST:event_formInternalFrameOpened

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        udfSave();
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        this.dispose();
    }//GEN-LAST:event_jButton2ActionPerformed

    private void chkAllActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkAllActionPerformed
        for(int i=0; i<jTable1.getRowCount(); i++){
            ((DefaultTableModel)jTable1.getModel()).setValueAt(chkAll.isSelected(), i, 2);
        }
    }//GEN-LAST:event_chkAllActionPerformed

    private void cmbGroupActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmbGroupActionPerformed
        
    }//GEN-LAST:event_cmbGroupActionPerformed

    private void cmbGroupItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_cmbGroupItemStateChanged
        if(cmbGroup.getSelectedIndex()>=0)
            udfLoadMenuUserAuth();
    }//GEN-LAST:event_cmbGroupItemStateChanged


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox chkAll;
    private javax.swing.JComboBox cmbGroup;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JTable jTable1;
    // End of variables declaration//GEN-END:variables

}
